// ==============================================================
// File generated by Vivado(TM) HLS - High-Level Synthesis from C, C++ and SystemC
// Version: 2015.3
// Copyright (C) 2015 Xilinx Inc. All rights reserved.
//
// ==============================================================

#ifndef XV_TPG_H
#define XV_TPG_H

#ifdef __cplusplus
extern "C" {
#endif

/***************************** Include Files *********************************/
#ifndef __linux__
#include "xil_types.h"
#include "xil_assert.h"
#include "xstatus.h"
#include "xil_io.h"
#else
#include <stdint.h>
#include <assert.h>
#include <dirent.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/mman.h>
#include <unistd.h>
#include <stddef.h>
#endif
#include "xv_tpg_hw.h"

/**************************** Type Definitions ******************************/
#ifdef __linux__
typedef uint8_t U8_T;
typedef uint16_t U16_T;
typedef uint32_t U32_T;
#else

/**
 * This typedef enumerates the different patterns supported by TPG
 */
typedef enum
{
  XTPG_BKGND_H_RAMP = 1,
  XTPG_BKGND_V_RAMP,
  XTPG_BKGND_TEMPORAL_RAMP,
  XTPG_BKGND_SOLID_RED,
  XTPG_BKGND_SOLID_GREEN,
  XTPG_BKGND_SOLID_BLUE,
  XTPG_BKGND_SOLID_BLACK,
  XTPG_BKGND_SOLID_WHITE,
  XTPG_BKGND_COLOR_BARS,
  XTPG_BKGND_ZONE_PLATE,
  XTPG_BKGND_TARTAN_COLOR_BARS,
  XTPG_BKGND_CROSS_HATCH,
  XTPG_BKGND_RAINBOW_COLOR,
  XTPG_BKGND_HV_RAMP,
  XTPG_BKGND_CHECKER_BOARD,
  XTPG_BKGND_PBRS,
  XTPG_BKGND_DP_COLOR_RAMP,
  XTPG_BKGND_DP_BW_VERTICAL_LINE,
  XTPG_BKGND_DP_COLOR_SQUARE,
  XTPG_BKGND_LAST
}XTpg_PatternId;

/**
* This typedef contains configuration information for the tpg core
* Each core instance should have a configuration structure associated.
*/
typedef struct {
    U16_T DeviceId;          /**< Unique ID  of device */
    UINTPTR BaseAddress;   /**< The base address of the core instance. */
    U16_T HasAxi4sSlave;     /**< Axi4s Slave capability indicator */
    U16_T PixPerClk;         /**< Samples Per Clock supported by core instance */
    U16_T NumVidComponents;  /**< Number of Video Components */
    U16_T MaxWidth;          /**< Maximum columns supported by core instance */
    U16_T MaxHeight;         /**< Maximum rows supported by core instance */
    U16_T MaxDataWidth;      /**< Maximum Data width of each channel */
	U16_T SolidColorEnable;  /**< Axi4s Slave capability indicator */
	U16_T RampEnable;        /**< Axi4s Slave capability indicator */
	U16_T ColorBarEnable;    /**< Axi4s Slave capability indicator */
	U16_T DisplayPortEnable; /**< Axi4s Slave capability indicator */
	U16_T ColorSweepEnable;  /**< Axi4s Slave capability indicator */
	U16_T ZoneplateEnable;   /**< Axi4s Slave capability indicator */
	U16_T ForegroundEnable;  /**< Axi4s Slave capability indicator */
} XV_tpg_Config;
#endif

/**
* Driver instance data. An instance must be allocated for each core in use.
*/
typedef struct {
    XV_tpg_Config Config;  /**< Hardware Configuration */
    U32_T IsReady;           /**< Device is initialized and ready */
} XV_tpg;

/***************** Macros (Inline Functions) Definitions *********************/
#ifndef __linux__
#define XV_tpg_WriteReg(BaseAddress, RegOffset, Data) \
    Xil_Out32((BaseAddress) + (RegOffset), (U32_T)(Data))
#define XV_tpg_ReadReg(BaseAddress, RegOffset) \
    Xil_In32((BaseAddress) + (RegOffset))
#else
#define XV_tpg_WriteReg(BaseAddress, RegOffset, Data) \
    *(volatile U32_T*)((BaseAddress) + (RegOffset)) = (U32_T)(Data)
#define XV_tpg_ReadReg(BaseAddress, RegOffset) \
    *(volatile U32_T*)((BaseAddress) + (RegOffset))

#define Xil_AssertVoid(expr)    assert(expr)
#define Xil_AssertNonvoid(expr) assert(expr)

#define XST_SUCCESS             0
#define XST_DEVICE_NOT_FOUND    2
#define XST_OPEN_DEVICE_FAILED  3
#define XIL_COMPONENT_IS_READY  1
#endif

/************************** Function Prototypes *****************************/
#ifndef __linux__
int XV_tpg_Initialize(XV_tpg *InstancePtr, U16_T DeviceId);
XV_tpg_Config* XV_tpg_LookupConfig(U16_T DeviceId);
int XV_tpg_CfgInitialize(XV_tpg *InstancePtr,
                         XV_tpg_Config *ConfigPtr,
                         UINTPTR EffectiveAddr);
#else
int XV_tpg_Initialize(XV_tpg *InstancePtr, const char* InstanceName);
int XV_tpg_Release(XV_tpg *InstancePtr);
#endif

void XV_tpg_Start(XV_tpg *InstancePtr);
U32_T XV_tpg_IsDone(XV_tpg *InstancePtr);
U32_T XV_tpg_IsIdle(XV_tpg *InstancePtr);
U32_T XV_tpg_IsReady(XV_tpg *InstancePtr);
void XV_tpg_EnableAutoRestart(XV_tpg *InstancePtr);
void XV_tpg_DisableAutoRestart(XV_tpg *InstancePtr);

void XV_tpg_Set_height(XV_tpg *InstancePtr, U32_T Data);
U32_T XV_tpg_Get_height(XV_tpg *InstancePtr);
void XV_tpg_Set_width(XV_tpg *InstancePtr, U32_T Data);
U32_T XV_tpg_Get_width(XV_tpg *InstancePtr);
void XV_tpg_Set_bckgndId(XV_tpg *InstancePtr, U32_T Data);
U32_T XV_tpg_Get_bckgndId(XV_tpg *InstancePtr);
void XV_tpg_Set_ovrlayId(XV_tpg *InstancePtr, U32_T Data);
U32_T XV_tpg_Get_ovrlayId(XV_tpg *InstancePtr);
void XV_tpg_Set_maskId(XV_tpg *InstancePtr, U32_T Data);
U32_T XV_tpg_Get_maskId(XV_tpg *InstancePtr);
void XV_tpg_Set_motionSpeed(XV_tpg *InstancePtr, U32_T Data);
U32_T XV_tpg_Get_motionSpeed(XV_tpg *InstancePtr);
void XV_tpg_Set_colorFormat(XV_tpg *InstancePtr, U32_T Data);
U32_T XV_tpg_Get_colorFormat(XV_tpg *InstancePtr);
void XV_tpg_Set_crossHairX(XV_tpg *InstancePtr, U32_T Data);
U32_T XV_tpg_Get_crossHairX(XV_tpg *InstancePtr);
void XV_tpg_Set_crossHairY(XV_tpg *InstancePtr, U32_T Data);
U32_T XV_tpg_Get_crossHairY(XV_tpg *InstancePtr);
void XV_tpg_Set_ZplateHorContStart(XV_tpg *InstancePtr, U32_T Data);
U32_T XV_tpg_Get_ZplateHorContStart(XV_tpg *InstancePtr);
void XV_tpg_Set_ZplateHorContDelta(XV_tpg *InstancePtr, U32_T Data);
U32_T XV_tpg_Get_ZplateHorContDelta(XV_tpg *InstancePtr);
void XV_tpg_Set_ZplateVerContStart(XV_tpg *InstancePtr, U32_T Data);
U32_T XV_tpg_Get_ZplateVerContStart(XV_tpg *InstancePtr);
void XV_tpg_Set_ZplateVerContDelta(XV_tpg *InstancePtr, U32_T Data);
U32_T XV_tpg_Get_ZplateVerContDelta(XV_tpg *InstancePtr);
void XV_tpg_Set_boxSize(XV_tpg *InstancePtr, U32_T Data);
U32_T XV_tpg_Get_boxSize(XV_tpg *InstancePtr);
void XV_tpg_Set_boxColorR(XV_tpg *InstancePtr, U32_T Data);
U32_T XV_tpg_Get_boxColorR(XV_tpg *InstancePtr);
void XV_tpg_Set_boxColorG(XV_tpg *InstancePtr, U32_T Data);
U32_T XV_tpg_Get_boxColorG(XV_tpg *InstancePtr);
void XV_tpg_Set_boxColorB(XV_tpg *InstancePtr, U32_T Data);
U32_T XV_tpg_Get_boxColorB(XV_tpg *InstancePtr);
void XV_tpg_Set_enableInput(XV_tpg *InstancePtr, U32_T Data);
U32_T XV_tpg_Get_enableInput(XV_tpg *InstancePtr);
void XV_tpg_Set_passthruStartX(XV_tpg *InstancePtr, U32_T Data);
U32_T XV_tpg_Get_passthruStartX(XV_tpg *InstancePtr);
void XV_tpg_Set_passthruStartY(XV_tpg *InstancePtr, U32_T Data);
U32_T XV_tpg_Get_passthruStartY(XV_tpg *InstancePtr);
void XV_tpg_Set_passthruEndX(XV_tpg *InstancePtr, U32_T Data);
U32_T XV_tpg_Get_passthruEndX(XV_tpg *InstancePtr);
void XV_tpg_Set_passthruEndY(XV_tpg *InstancePtr, U32_T Data);
U32_T XV_tpg_Get_passthruEndY(XV_tpg *InstancePtr);
void XV_tpg_Set_dpDynamicRange(XV_tpg *InstancePtr, U32_T Data);
U32_T XV_tpg_Get_dpDynamicRange(XV_tpg *InstancePtr);
void XV_tpg_Set_dpYUVCoef(XV_tpg *InstancePtr, U32_T Data);
U32_T XV_tpg_Get_dpYUVCoef(XV_tpg *InstancePtr);

void XV_tpg_InterruptGlobalEnable(XV_tpg *InstancePtr);
void XV_tpg_InterruptGlobalDisable(XV_tpg *InstancePtr);
void XV_tpg_InterruptEnable(XV_tpg *InstancePtr, U32_T Mask);
void XV_tpg_InterruptDisable(XV_tpg *InstancePtr, U32_T Mask);
void XV_tpg_InterruptClear(XV_tpg *InstancePtr, U32_T Mask);
U32_T XV_tpg_InterruptGetEnabled(XV_tpg *InstancePtr);
U32_T XV_tpg_InterruptGetStatus(XV_tpg *InstancePtr);

#ifdef __cplusplus
}
#endif

#endif
